class HueBridge {
    constructor(ip, user) {
        this._ip = ip
        this._user = user
    }

    sendRequest(method, path, body) {
        const url = `http://${this._ip}/api/${this._user}${path}`

        return new Promise((resolve, reject) => {
            let req = new XMLHttpRequest()
            req.addEventListener('load', () => {
                resolve(JSON.parse(req.responseText))
            })
            req.open(method, url)
            req.setRequestHeader('Content-type', 'application/json')

            req.send(body)
        })
    }

    getLights() {
        return this.sendRequest('GET', '/lights/')
    }

    setLightState(light_id, state) {
        return this.sendRequest('PUT', `/lights/${light_id}/state`, JSON.stringify(state))
    }
}

const newUser = ip => {
    const url = `http://${ip}/api`
    
    return new Promise((resolve, reject) => {
        // error: resolve([{"error":{"type":101,"address":"","description":"link button not pressed"}}])
        // success: resolve([{"success":{"username":"xyz"}}])

        let req = new XMLHttpRequest()
        req.addEventListener('load', () => {
            resolve(JSON.parse(req.responseText))
        })
        req.open('POST', url)
        req.setRequestHeader('Content-type', 'application/json')
        req.send(JSON.stringify({'devicetype': 'my_hue_app#port6'}))
    })
}

const discoverBridges = () => {
    const url = 'https://discovery.meethue.com/'
    
    return new Promise((resolve, reject) => {
        // resolve([{"id":"abcd","internalipaddress":"192.168.2.29","port":443}]) // toimisto (varmaan vaihtuu)
        // resolve([{"id":"abcd","internalipaddress":"192.168.1.44","port":443}]) // Felix koti

        let req = new XMLHttpRequest()
        req.addEventListener('load', () => {
            resolve(JSON.parse(req.responseText))
        })
        req.open('GET', url)
        req.send()
    })
}